precision highp float; // Define float precision
precision highp int;   // Define int precision

uniform sampler2D u_texture;
varying vec4 v_color;
varying vec2 v_texCoords;//between uv,uv2
uniform vec2 uv,uv2;
uniform vec2 resolution;

uniform float f_thickness;//1.0
uniform vec4 cl_outline;//color
float GetAlpha(vec2 tex){
	if (tex.x<uv.x || tex.x>uv2.x) return 0.0;
	if (tex.y<uv.y || tex.y>uv2.y) return 0.0;
	float a = texture2D(u_texture, tex).a;
	if (a>=1.0) return 1.0;
	return 0.0;
}
vec4 GetColor(){
	vec4 col = texture2D(u_texture, v_texCoords);
	if (col.a >= 1.0) return col;
	vec2 offset = f_thickness/resolution;
	vec2 del = (uv2-uv);
	if (length(del)>0.0) offset = offset*del;
	float a = GetAlpha(vec2(v_texCoords.x + offset.x, v_texCoords.y)) +
	GetAlpha(vec2(v_texCoords.x, v_texCoords.y - offset.y)) +
	GetAlpha(vec2(v_texCoords.x - offset.x, v_texCoords.y)) +
	GetAlpha(vec2(v_texCoords.x, v_texCoords.y + offset.y));
	if (a > 0.0) return cl_outline;//outline
	return col;
}
void main(){
	gl_FragColor = GetColor() * v_color;
}