precision highp float; // Define float precision
precision highp int;   // Define int precision

uniform sampler2D u_texture;
varying vec4 v_color;
varying vec2 v_texCoords;//between uv,uv2
uniform vec2 uv;
uniform vec2 uv2;
uniform vec2 resolution;
uniform float time;

uniform vec2 v2_scrollSpeed;
uniform vec2 v2_percent;//0f-1f

vec2 UV(){//0f->1f
    return (v_texCoords-uv)/(uv2-uv);
}
vec2 applyRegionOffset(vec2 position, vec4 regionUV) {
    vec2 size = vec2(regionUV.z - regionUV.x, regionUV.w - regionUV.y);
    position = position * size + regionUV.xy;
    return position;
}
void main() {
    vec4 uvRegion = vec4(uv.x,uv.y,uv2.x,uv2.y);
    vec4 color = texture2D(u_texture, applyRegionOffset(fract((v_texCoords - 0.5)/(vec2(1.0, 1.0)) + 0.5 + v2_scrollSpeed*time), uvRegion));
    vec2 mainUV = UV();
    if (mainUV.x>v2_percent.x || mainUV.y>v2_percent.y) color.a = 0.0;
    gl_FragColor = color*v_color;
}